function CT=commute_time_1(a);

%commute time by eq. (8)

L=sym_laplacian(a);
[phi v]=eig(L);
[vs ord]=sort(diag(v));

phi=phi(:,ord);

n=length(a);

d=1./sqrt(sum(a,2));
vol=sum(sum(a));

CT=zeros(n);

for i=1:n
   for j=1:n
      for k=2:n
         CT(i,j)=CT(i,j) + ((phi(i,k)*d(i) - phi(j,k)*d(j))^2)/vs(k);      
      end;
   end
end;
CT=vol*CT;


