function CT=commute_time_2(a);

%commute time by eq. (9)
L=com_laplacian(a);
[phi v]=eig(L);
[vs ord]=sort(diag(v));

phi=phi(:,ord);

n=length(a);

vol=sum(sum(a));

CT=zeros(n);

for i=1:n
   for j=1:n
      for k=2:n
         CT(i,j)=CT(i,j) + ((phi(i,k) - phi(j,k))^2)/vs(k);      
      end;
   end
end;
CT=vol*CT;

