clear all; close all;

A = load('gr5_2.adj');

n = length(A);
pos = n;
ord = 1:n;
ord(pos)=[];
ord = [ord pos]

A = A(ord,ord);

L = diag(sum(A,2)) - A;
L1 = L(1:n-1,1:n-1);
save lap1.adj L1 -ascii
d = sum(A,2);
D = diag(1./d);

P = D*A;
P(n,:) = 0;
P(n,n) = 1;

[U,V] = eig(P);
[vs,is] = sort(-diag(abs(V)));
vs = -vs;
u = U(:,is(2));

Q = P(1:n-1,1:n-1);
[UQ, VQ] = eig(Q);
[vq, iq] = sort(-diag(abs(VQ)));
vq = -vq;

%agreement between eigenvectors of the matrices P and Q
err1 = norm(vs -[1; vq])

err = [];
for j=1:n-1
   err = [err; sum(abs(U(:,is(j+1)) - [UQ(:,iq(j)); 0]))];
end; 

%%%
%%% Eigenvectors of matrices Q and Q1=Dpl*Q*Dmn

Dmn = diag(1./sqrt(d(1:n-1)));
Dpl = diag(sqrt(d(1:n-1)));
Q1  = Dpl*Q*Dmn; %normalizowana macierz Q
[UQ1, VQ1] = eig(Q1);
[vq1, iq1] = sort(-diag(VQ1));
vq1 = -vq1;
[vq vq1 abs(vq-vq1)]
err1 = [];
nn = Dpl*UQ;
for j=1:n-1
   nn(:,j) = nn(:,j)/norm(nn(:,j));
end;

for j=1:n-1
   err1 = [err1; sum(abs( abs(nn(:,iq(j))) - abs(UQ1(:,iq1(j)))))];
end; 
err1

%%%
%%%
%%%

time = inv(eye(n-1) - Q)*ones(n-1,1);
[ts its] = sort(time);

v1 = UQ(:,iq(1));
lamb1 = vq(1);
time1 = ones(n-1,1) + lamb1/(1-lamb1)*v1*v1'*d(1:n-1);

figure(1); plot(vq,'k-*');
figure(2); plot(time,'k-*'); hold on; plot(time1,'r-*');
figure(3); plot(ts,time1(its),'k-*');
